#ifndef FLO_ATTRIBUTE_H
#define FLO_ATTRIBUTE_H

#include <string>
#include <vector>

#include "xmlwrap.h"

// TODO: multithread protection, multivalued, typed
class FlOAttribute {
 private:
  static const std::string empty_value;
  bool multivalue_;
  std::string name_;
  std::vector<std::string> value_;
 public:
  FlOAttribute(void):name_("") { };
  FlOAttribute(const std::string& name,bool multi = false):name_(name),multivalue_(multi) { };
  FlOAttribute(const std::string& name,const std::string& value,bool multi = false):name_(name),multivalue_(multi) { value_.push_back(value); };
  FlOAttribute(const std::string& name,const std::vector<const std::string>& value):name_(name),multivalue_(true) {
    for(std::vector<const std::string>::const_iterator i = value.begin();
           i!=value.end();++i) {
      value_.push_back(*i);
    };
  };
  ~FlOAttribute(void);
  const std::string& name(void) const { return name_; };
  const std::string& value(unsigned int n = 0) const {
    if(value_.size() > n) return value_[n];
    return empty_value;
  };
  void value(const std::string& v) { value_.clear(); value_.push_back(v); };
  bool add(const std::string& v) {
    if((value_.size()>0) and (!multivalue_)) return false;
    value_.push_back(v);
    return true;
  };
  bool operator==(const std::string& n) const { return (name_ == n); };
  void serialize(XMLNode& x) const;
  static FlOAttribute* deserialize(const XMLNode& x);
};

#endif // FLO_ATTRIBUTE_H

