#include "../../std.h"

#include "flo_soap.nsmap"
extern SOAP_NMAC struct Namespace flo_soap_namespaces[];

#include "client.h"

// -------------------------------------------------
// SOAP client

FlOClient::FlOClient(pFlOServiceRemote s):HTTP_ClientSOAP(s->url().c_str(),&soap) {
  soap.namespaces=flo_soap_namespaces;
}

FlOClient::FlOClient(FlOServiceRemote& s):HTTP_ClientSOAP(s.url().c_str(),&soap) {
  soap.namespaces=flo_soap_namespaces;
}

FlOClient::~FlOClient(void) {
  disconnect();
}

bool FlOClient::registr(FlOService& s) {
  struct nf__response r;
  int soap_err = soap_call_nf__registration(&soap,SOAP_URL(),
                    "registration",(char*)(s.url().c_str()),NULL,NULL,r);
  if(soap_err != SOAP_OK) { 
    disconnect(); return false;
  };
  if(r.error_code != 0) {
    return false;
  };
  return true;
} 

bool FlOClient::notify(list<FlOMessage>& msgs) {
  if(msgs.size() <= 0) return true;
  struct nf__response r;
  char** msgs_ = (char**)soap_malloc(&soap,sizeof(char*)*msgs.size());
  if(msgs_ == NULL) return false;
  int n = 0;
  for(list<FlOMessage>::iterator msg = msgs.begin();msg!=msgs.end();++msg) {
    std::string m;
    msg->serialize(m);
    msgs_[n] = soap_strdup(&soap,m.c_str());
    odlog(4)<<"FlOClient: notify: message: "<<msgs_[n]<<endl;
    n++;
  };
  int soap_err = soap_call_nf__notification(&soap,SOAP_URL(),
                                   "notification",n,msgs_,r);
  if(soap_err != SOAP_OK) { 
    disconnect(); return false;
  };
  if(r.error_code != 0) {
    return false;
  };
  return true;
}

