#include "../std.h"

#include <iostream>
#include <fstream>

#include "../files/info_types.h"

#include "jsdl_job.h"

int main(void) {
 
  std::fstream f("jsdl_example.xml");
  if(!f.is_open()) {
    std::cerr<<"cant open file"<<std::endl;
    return 1;
  };
  JobLocalDescription desc;
  std::string acl;
  JSDLJob j(f);
  if(!j) { std::cout<<"failed parsing"<<std::endl; };
  j.parse(desc,&acl);
  std::cout<<"stdin: "<<desc.stdin<<std::endl;
  std::cout<<"stdout: "<<desc.stdout<<std::endl;
  std::cout<<"stderr: "<<desc.stderr<<std::endl;
  for(std::list<std::string>::iterator i = desc.arguments.begin();
                 i!=desc.arguments.end();++i) {
    std::cout<<"arg: "<<*i<<std::endl;
  };
  std::cout<<std::endl;
  return 0;
}
